{{
************************************
* jvmError - error support for jvm *
************************************
}}


CON
  'jvm errors as defined by the javelin IDE
  ERR_TOO_MANY_METHODS        = 1  ' "Too many methods in class.", "The class already contains the maximum number of methods.", "Increase the number of methods a class may have." 
  ERR_STACK_OVERFLOW          = 2  ' "Stack overflow.", "The stack is too small and has overflowed.", "Increase the size of the virtual machine stack." 
  ERR_STACK_UNDERFLOW         = 3  ' "Stack underflow.", "Attempt to pop from an empty stack.", "This indicates a bug in the linker."
  ERR_UNDEFINED_INSTRUCTION   = 4  ' "Undefined instruction.", "Attempt to execute an unknown instruction.", "This indicates a bug in the linker."
  ERR_NO_RETURN               = 5  ' "No `return' instruction found.", "A program must end with a `return' instruction but none was found.", "This indicates a bug in the linker."
  ERR_DIVIDE_BY_ZERO          = 6  ' "Divide by zero.", "An attempt was made to divde by zero.", "Check the statement."
  ERR_POOLINDEX_OUT_OF_RANGE  = 7  ' "Constant pool index out of range.", "An index into the constant pool is incorrect.", "This indicates a bug in the linker."
  ERR_UNRESOLVED_FUNCTIONNAME = 8  ' "Unable to resolve function name.","The name of a function could not be resolved.", "Check the statement."
  ERR_POOL_FULL               = 9  ' "Constant pool full.", "The constant pool is full.", "Increase the size of the constant pool or simplify the statement." 
  ERR_TOO_MANY_ARGS           = 10 ' "Too many arguments to function.", "Too many arguments were given in a function call.", "Correct the statement." 
  ERR_UNRESOLVED_LOCALNAME    = 11 ' "Unable to resolve local variable name.","The name of a local variable could not be resolved.", "Check the statement." 
  ERR_BUFFER_OVERFLOW         = 12 ' "Program buffer overflow.", "Program code buffer is too small and has overflowed.", "This indicates an internal error." 
  ERR_NO_CODE_ATTRIBUTE       = 13 ' "No `Code' attribute for method.", "The code for a method could not be located.", "This indicates an internal error." 
  ERR_NO_METHOD_FOUND         = 14 ' "No method found for `%s'.", "A method could not be found by name.", "This indicates an internal error." 
  ERR_METHOD_ARG_CORRUPT      = 15 ' "Method arguments corrupt.", "The arguments to a method have become corrupt.", "This indicates an internal error." 
  ERR_THIS_NULL               = 16 ' "Reference to `this' is null in function call.", "", "This indicates an internal error." 
  ERR_CANNOT_LOAD_CLASS       = 17 ' "Unable to load class file: `%s', '%s'.", "The file does not exist or you do not have permission to read it.", "Check that the file exists and you have the correct permissions." 
  ERR_FILE_NOT_CLASS          = 18 ' "File does not contain a Java class: `%s'.", "The file is not a Java class file or it is corrupt.", "Check the path is correct and replace the file if necessary." 
  ERR_CANNOT_READ_CLASS       = 19 ' "Cannot read Java class file: `%s'. Version not supported.", "The version of the class file is either too new or too old.", "Try recompiling the class with a different compiler version." 
  ERR_CLASS_CORRUPTED         = 20 ' "Java class file corrupt: `%s'.", "There is a corruption in the class file or a bug in the class loader.", "Report the error to technical support." 
  ERR_UNKNOWN_TAG             = 21 ' "Unknown tag (%d) in java class file: `%s'.", "There is a corruption in the class file or a bug in the class loader.", "Report the error to technical support." 
  ERR_METHOD_DEFINITION       = 22 ' "Unknown parameter (`%c') in definition of method `%s'.", "There is a corruption in the class file or a bug in the class loader.", "Try recompiling the class, or report the error to technical support."
  ERR_CODEINDEX_OUT_OF_RANGE  = 23 ' "Code index out of range.", "There is a corruption in the class file or a bug in the class loader.", "Try recompiling the class, or report the error to technical support."
  ERR_NO_DEBUGINFO            = 24 ' "No debug info in class file `%s'.", "The debug information could not be found. Either the class was not compiled with debugging information or an internal error has occured.", "Compile the class with the `-g' flag."
  ERR_UNKNOWN_PARAMETER       = 25 ' "Unknown parameter (`%c').", "There is a corruption in the class file or a bug in the class loader.", "Report the error to technical support."
  ERR_NO_LINEINFO             = 26 ' "No line number info in class file `%s'.", "The line number information could not be found. Either the class was not compiled with debugging information or a compiler generated method is being executed.", "Compile the class with the `-g' flag, or use 'run' rather than 'step'."
  ERR_INVALID_LOCALINDEX      = 27 ' "Invalid local variable index.", "An invalid local variable index was used.", "Report the error to technical support."
  ERR_NO_LINKED_FIELD         = 28 ' "Cannot find linked field (%s.%s).", "The named field could not be found.", "Report the error to technical support."
  ERR_CONSTANT_OUT_OF_RANGE   = 29 ' "Method %s::%s contains a constant out of range (%s).", "The class contains a constant which is out of the range allowed in a JEM file.", "Restrict variables to those allowed in JEM files."
  ERR_UNIMPLEMENTED_BYTECODE  = 30 ' "Unimplemented bytecode ($%02X).", "An unimplemented bytecode was encountered.", "Check that your source file complies with the JavaCard specification."
  ERR_LINKED_METHOD_NOT_FOUND = 31 ' "Cannot find linked method (%s.%s).", "The named method could not be found.", "Report the error to technical support."
  ERR_INTERFACE_NOT_SUPPORTED = 32 ' "Interfaces are not currently supported.", "Interfaces are not support in this version.", "You tried to load or link a class that uses interfaces. Report that you want to use interfaces to technical support."

  NO_ERROR = 0

  
OBJ
  comm: "jvmComm"   'communication port object

  
PUB printError(errcode)
{{ error support }}
  comm.error(errcode)
            
      